import usb


VENDOR_RQ_GET_LIGHT0  = 0
VENDOR_RQ_GET_LIGHT1  = 1
VENDOR_RQ_SET_LED     = 2
VENDOR_RQ_GET_LIGHT3  = 3
VENDOR_RQ_GET_LIGHT4  = 4
VENDOR_RQ_GET_LIGHT5  = 5


####################################
class Board:
    def __init__(self):
        #print "Looking for MCU board..."
        dev = self.find_board()
        if not dev: raise "MCU board not found!"
        #print "MCU board found"
        self.handle = dev.open()

    def find_board(self):
        for bus in usb.busses():
            for dev in bus.devices:
                if dev.idVendor == 0x16c0 and dev.idProduct == 0x05dc:
                    return dev
        return None

    def set_led(self,pin,val):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
        self.handle.controlMsg(reqType, VENDOR_RQ_SET_LED, None, value=val*256+pin)

    def get_light0(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        light = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT0, 2)
        return light[0] + light[1]*256

    def get_light1(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        light = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT1, 2)
        return light[0] + light[1]*256

    def get_light3(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        light = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT3, 2)
        return light[0] + light[1]*256

    def get_light4(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        light = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT4, 2)
        return light[0] + light[1]*256

    def get_light5(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        light = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT5, 2)
        return light[0] + light[1]*256
